//+------------------------------------------------------------------+
//|   RSI OBOS + Tester                                              |
//|                                                                  |
//|   Copyright  2014 / airquest@hotmail.com                        |
//|                                                                  |
//|   http://smart-trading.world-record.ch                           |
//+------------------------------------------------------------------+


   #property copyright   "Copyright  2014 // airquest // smart-trading.world-record.ch"
   #property link        "http://smart-trading.world-record.ch"
   #property description "RSI OBOS + Tester"


//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 2

//+------------------------------------------------------------------+ Backtest

extern int    MinutesExpiry = 15;
extern bool   RunBacktest   = True;

//+------------------------------------------------------------------+

extern bool   ShowArrows  = True;

extern int    RsiPeriod  =   7;
extern int    RsiPrice   = PRICE_CLOSE;
extern int    RsiOBLevel =  70;
extern int    RsiOSLevel =  30;

extern double ArrowsDisplacement = 0.8;
extern color  ArrowsUpColor      = Lime;
extern color  ArrowsDnColor      = Red;
extern int    ArrowsUpCode       = 233;
extern int    ArrowsDnCode       = 234;
extern int    ArrowsWidth        = 3;

extern color  LabelBuyColor  = Lime;
extern color  LabelSellColor = Red;
extern int    LabelFontWidth = 14;
extern int    LabelCorner    =  1;
extern int    LabelYDistance =  0;
extern int    LabelXDistance =  0;
extern string UniqueID       = "RSI+ADX";


double ArrowsBuy[];
double ArrowsSell[];
double trend[];

//+------------------------------------------------------------------+ Backtest

double count[];
double itm[];
double expiry_price[];

int    count_total, count_itm, count_otm;
double count_winrate;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(6);

   SetIndexBuffer(0,ArrowsBuy);  SetIndexStyle(0,DRAW_ARROW,NULL,ArrowsWidth,ArrowsUpColor); SetIndexArrow(0,ArrowsUpCode);
   SetIndexBuffer(1,ArrowsSell); SetIndexStyle(1,DRAW_ARROW,NULL,ArrowsWidth,ArrowsDnColor); SetIndexArrow(1,ArrowsDnCode);
   SetIndexBuffer(2,trend);
   
//+------------------------------------------------------------------+ Backtest
   
   SetIndexBuffer(3,count);
   SetIndexBuffer(4,itm);
   SetIndexBuffer(5,expiry_price);

//+------------------------------------------------------------------+

   if(!ShowArrows) { SetIndexStyle(0,DRAW_NONE); SetIndexStyle(1,DRAW_NONE); }

   return(0);
}

int deinit()
{
   
//+------------------------------------------------------------------+ Backtest
   
   DeleteBackTest();

//+------------------------------------------------------------------+

   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   int limit=MathMin(Bars-counted_bars,Bars-1);

   for(int i=limit; i>=0; i--)
     {
         double rsi = iRSI(NULL,0,RsiPeriod,RsiPrice,i);

         trend[i] = trend[i+1];

         if      (rsi <= RsiOSLevel) trend[i] =  1;
         else if (rsi >= RsiOBLevel) trend[i] = -1;
         else                        trend[i] =  0;

         double gap  = iATR(NULL,0,100,i);
         double high = High[i] + gap * ArrowsDisplacement;
         double low  = Low[i]  - gap * ArrowsDisplacement;

         ArrowsBuy[i]  = EMPTY_VALUE;
         ArrowsSell[i] = EMPTY_VALUE;

         if(trend[i] != trend[i+1] && trend[i] ==  1)
         {
            ArrowsBuy[i]  = low;
         }
         
         else if(trend[i] != trend[i+1] && trend[i] == -1)
         {
            ArrowsSell[i] = high;
         }
     }

//+------------------------------------------------------------------+ Backtest

   if(RunBacktest)
   {
      for(i=limit; i>=0; i--)
        {
            datetime time_for_entry = iTime(NULL,0,i-1);                     //(Here the entry time is the next bar Open time)
            datetime expiry_time    = time_for_entry + MinutesExpiry * 60;   //Takes the expiry time in MinutesExpiry setting

            //(1)Calculates expiry price based on minutes
            expiry_price[i] = iClose(NULL,PERIOD_M1,iBarShift(NULL,PERIOD_M1,expiry_time,True));

            //(2)Calculates expiry_price based on candles
            //expiry_price[i] = iClose(NULL,0,i-MinutesExpiry/Period());

            //Conditions for signals
            if   (ArrowsBuy[i] != EMPTY_VALUE || ArrowsSell[i] != EMPTY_VALUE)
                 count[i] = 1;
            else count[i] = 0;

            //Conditions for ITM (here the entry price is the next bar Open price)
            if   ((ArrowsBuy[i]  != EMPTY_VALUE && Open[i-1] < expiry_price[i]) || (ArrowsSell[i] != EMPTY_VALUE && Open[i-1] > expiry_price[i]))
                 itm[i] = 1;
            else itm[i] = 0;
        }

        for(i=0; i<=limit; i++)
        {
            count_total += count[i];
            count_itm   += itm[i];
            count_otm    = count_total - count_itm;
        }

        count_winrate = count_itm * 100 / count_total;

        //Use the following lines if expiry_price calculation is based on minutes (Method 1)
        BackTest(count_total,count_itm,count_otm,count_winrate);

        //Use the following lines if expiry_price calculation is based on candles (Method 2)
        //if(Period() <= MinutesExpiry) BackTest(count_total,count_itm,count_otm,count_winrate);
        //else Alert("TimeFrame must be equal or less than expiry time in minutes for backtest to run properly");
   }

//+------------------------------------------------------------------+

   return(0);
}

//+------------------------------------------------------------------+ Backtest

void BackTest(int total_of_trades, int total_itm, int total_otm, double total_winrate)
{
   string name = UniqueID+" BackTest";
   color Color_Winrate; if (total_winrate < 50) Color_Winrate = Red; else Color_Winrate = Green;
   
   ObjectCreate(0,name+"1",OBJ_LABEL,0,Time[0],Close[0]);
   ObjectSetText(name+"1","Signals: "+IntegerToString(total_of_trades),15,NULL,Green);
   ObjectSet(name+"1",OBJPROP_XDISTANCE,LabelXDistance+90);
   ObjectSet(name+"1",OBJPROP_YDISTANCE,LabelYDistance+50);
   ObjectSet(name+"1",OBJPROP_CORNER,LabelCorner);
   ObjectSet(name+"1",OBJPROP_ANCHOR,ANCHOR_CENTER);
   
   ObjectCreate(0,name+"2",OBJ_LABEL,0,Time[0],Close[0]);
   ObjectSetText(name+"2","Win",12,NULL,Green);
   ObjectSet(name+"2",OBJPROP_XDISTANCE,LabelXDistance+150);
   ObjectSet(name+"2",OBJPROP_YDISTANCE,LabelYDistance+75);
   ObjectSet(name+"2",OBJPROP_CORNER,LabelCorner);
   ObjectSet(name+"2",OBJPROP_ANCHOR,ANCHOR_CENTER);
   
   ObjectCreate(0,name+"3",OBJ_LABEL,0,Time[0],Close[0]);
   ObjectSetText(name+"3","Lose",12,NULL,Red);
   ObjectSet(name+"3",OBJPROP_XDISTANCE,LabelXDistance+100);
   ObjectSet(name+"3",OBJPROP_YDISTANCE,LabelYDistance+75);
   ObjectSet(name+"3",OBJPROP_CORNER,LabelCorner);
   ObjectSet(name+"3",OBJPROP_ANCHOR,ANCHOR_CENTER);
   
   ObjectCreate(0,name+"4",OBJ_LABEL,0,Time[0],Close[0]);
   ObjectSetText(name+"4","WinRate",12,NULL,Color_Winrate);
   ObjectSet(name+"4",OBJPROP_XDISTANCE,LabelXDistance+40);
   ObjectSet(name+"4",OBJPROP_YDISTANCE,LabelYDistance+75);
   ObjectSet(name+"4",OBJPROP_CORNER,LabelCorner);
   ObjectSet(name+"4",OBJPROP_ANCHOR,ANCHOR_CENTER);
   
   ObjectCreate(0,name+"5",OBJ_LABEL,0,Time[0],Close[0]);
   ObjectSetText(name+"5",IntegerToString(total_itm),12,NULL,Green);
   ObjectSet(name+"5",OBJPROP_XDISTANCE,LabelXDistance+150);
   ObjectSet(name+"5",OBJPROP_YDISTANCE,LabelYDistance+100);
   ObjectSet(name+"5",OBJPROP_CORNER,LabelCorner);
   ObjectSet(name+"5",OBJPROP_ANCHOR,ANCHOR_CENTER);
   
   ObjectCreate(0,name+"6",OBJ_LABEL,0,Time[0],Close[0]);
   ObjectSetText(name+"6",IntegerToString(total_otm),12,NULL,Red);
   ObjectSet(name+"6",OBJPROP_XDISTANCE,LabelXDistance+100);
   ObjectSet(name+"6",OBJPROP_YDISTANCE,LabelYDistance+100);
   ObjectSet(name+"6",OBJPROP_CORNER,LabelCorner);
   ObjectSet(name+"6",OBJPROP_ANCHOR,ANCHOR_CENTER);
   
   ObjectCreate(0,name+"7",OBJ_LABEL,0,Time[0],Close[0]);
   ObjectSetText(name+"7",DoubleToString(total_winrate,1)+"%",12,NULL,Color_Winrate);
   ObjectSet(name+"7",OBJPROP_XDISTANCE,LabelXDistance+40);
   ObjectSet(name+"7",OBJPROP_YDISTANCE,LabelYDistance+100);
   ObjectSet(name+"7",OBJPROP_CORNER,LabelCorner);
   ObjectSet(name+"7",OBJPROP_ANCHOR,ANCHOR_CENTER);
}

void DeleteBackTest()
{
   string name = UniqueID+" BackTest";
   for(int i=0; i<8; i++) ObjectDelete(name+""+i);
}

//+------------------------------------------------------------------+